#ifndef __NETLINK_OS__
#define	__NETLINK_OS__
#define	DISPATCH_TABLE_ADDRESS	0x06002F80

typedef short Err;
typedef void (*ErrorCallback)(Err inError);

typedef struct
{
	unsigned short gameDataQueueSize;
	unsigned short roundTripLatency;
	unsigned short packetSize;

	unsigned short errorRecoveriesCount;
	unsigned short badPacketCount;
	unsigned short noDataCount;
	unsigned short redialCount;
	unsigned short overrunErrorCount;
	unsigned short parityErrorCount;
	unsigned short frameErrorCount;
	unsigned long bytesReadCount;
	unsigned long bytesWrittenCount;
	unsigned long packetCount;	/* total number of game data packets sent back and forth */
} Info;


typedef enum _GameType GameType;
enum _GameType
{
	LocalGame = 0,
	PracticeGame = 1,
	NetworkGame = 2
};

typedef struct
{
	long masterScore;
	long slaveScore;
	char userData[32];
} GameResults;


typedef struct
{
void (*Null)(void);
int (*DebugInit)(void);
void (*MakeMaster)(char *);
void (*NotUsed2)(int);
void (*NotUsed3)(int,int,int);
void (*NotUsed4)(void);
void (*Free1)(void);
Err (*ExchangeGameData)(const void*,void*,void*);
const Info* (*GetInfo)(void);
GameType (*Init)(void(int));
const char* (*MasterPlayerName)(void);
const char* (*SlavePlayerName)(void);
const char* (*LocalPlayerName)(void);
const char* (*RemotePlayerName)(void);
int (*LocalIsMaster)(void);
Err (*CloseSession)(void);
unsigned long (*GetRandomSeed)(void);
int (*PracticeGameTask)(void);
void (*NetworkGameOver)(GameResults*,Err);
void (*SetErrorCallback)(ErrorCallback);
void (*StartModem)(void);
unsigned char (*Read)(int r4);
void (*Write)(int r4,unsigned char);
void (*VBLTask)(void);
int (*AllowReturnToOS)(void);
void (*TunnelConnect)(char *);
int (*PracticeTimeLeft)(void);
int (*ListenForCall)(void);
Err (*OpenSession)(int,int);
void (*HangupModem)(void);
void (*ReadyToExit)(void);
void (*Unknown1)(void);

} NetlinkOS;

#define NET  (*((volatile NetlinkOS*)(DISPATCH_TABLE_ADDRESS)))

#define MaxNameSize 34

#define NET_Release() (((int*) (DISPATCH_TABLE_ADDRESS-0x80))[  1] = ((int*) DISPATCH_TABLE_ADDRESS)[1] = ((int*) DISPATCH_TABLE_ADDRESS)[0])

#endif